Make any Liferay user to access Redmine (through LDAP Credentials)

Jun 23, 2015 03:25 PM - Massimiliano Assante

Status: Closed Start date: Jun 24, 2015

Priority: Immediate Due date: Jul 13, 2015

Assignee: Andrea Dell'Amico % Done: 100%

Category: System Application Estimated time: 0.00 hour

Target version: LiferayRedmineIntegration   

Infrastructure: Production   

Description

The Redmine instance for a given project should be accessed by any VRE user serving this project.

In this moment we are able to make Liferay pass the credentials to Redmine, which I assume check these credentials against the

research infrastructures LDAP (Our LDAP).

This solution works only with already registered user (both to LDAP and Redmine). The requirement is to make any Liferay user

having the possibility to log to Redmine. To do so Liferay has the export users capability to LDAP and this already works (although

I'm not sure where these users get saved).

Probably the only step missing, once we enable the export users in Liferay, is to associate the user to a given project in Redmine.

Any idea on how to do this?

Subtasks:

Task # 297: New ldap instance Closed

Task # 386: ssl certificate for ldap-liferay.d4science.org Closed

Support # 397: Export Liferay Portal users to LDAP Closed

Related issues:

Blocked by D4Science Infrastructure - Support #1407: Export Liferay Portal gr... Closed Nov 17, 2015

Blocked by D4Science Infrastructure - Task #1609: Change the Redmine LDAP Con... Closed Nov 30, 2015

History

#1 - Jun 23, 2015 03:26 PM - Massimiliano Assante

For example the users belonging to the PARTHENOS VRE should be able to join the Redmine instance of Parthenos

#2 - Jun 23, 2015 03:51 PM - Pasquale Pagano

- Priority changed from High to Urgent

#3 - Jun 23, 2015 04:09 PM - Andrea Dell'Amico

- Priority changed from Urgent to High

Massimiliano Assante wrote:

The Redmine instance for a given project should be accessed by any VRE user serving this project.

In this moment we are able to make Liferay pass the credentials to Redmine, which I assume check these credentials against the research

infrastructures LDAP (Our LDAP).

This solution works only with already registered user (both to LDAP and Redmine). The requirement is to make any Liferay user having the

possibility to log to Redmine. To do so Liferay has the export users capability to LDAP and this already works (although I'm not sure where these

users get saved).

 Inside our LDAP server, but I think it's a recipe for disaster.

If liferay can support more than ldap server, the export could be enabled for a second ldap completely separated from the ISTI one.

Probably the only step missing, once we enable the export users in Liferay, is to associate the user to a given project in Redmine. Any idea on

how to do this?

 I think it's possible leveraging some of the 'ldap sync plugin' options that we are not using. I don't know if it uses 'posixGroups' from the ldap tree. The

ldap and redmine groups should be the same, though.
The ldap sync plugin documentation is here: https://github.com/thorin/redmine_ldap_sync

#4 - Jun 23, 2015 04:09 PM - Andrea Dell'Amico

- Priority changed from High to Urgent

#5 - Jun 23, 2015 04:36 PM - Massimiliano Assante

Yes liferay can support more than one ldap server

#6 - Jun 23, 2015 05:32 PM - Luca Frosini

Massimiliano Assante so you can patch liferay to insert in the "external" LDAP the users instead of creating only on local database. With this feature

we can plan to have a SSO or a sort of it

#7 - Jun 24, 2015 10:43 AM - Massimiliano Assante

Luca Frosini wrote:

Massimiliano Assante so you can patch liferay to insert in the "external" LDAP the users instead of creating only on local database. With this

feature we can plan to have a SSO or a sort of it

 I can make Liferay export its users to any LDAP server, no patches are needed just LDAP coordinates and credentials 

#8 - Jul 09, 2015 06:35 PM - Pasquale Pagano

We need to complete this activity since we have more than 40 people registered to Liferay that need to use redmine. Without exporting Liferay users

in LDAP this is not possible. This task has to be completed asap

#9 - Jul 09, 2015 06:36 PM - Massimiliano Assante

- Target version changed from UnSprintable to LiferayRedmineIntegration

#10 - Jul 09, 2015 06:37 PM - Pasquale Pagano

- Due date set to Jul 13, 2015

due to changes in a related task

#11 - Jul 17, 2015 02:14 PM - Massimiliano Assante

- Status changed from New to In Progress

- Assignee changed from Andrea Dell'Amico to Massimiliano Assante

the ldap instance is ready, trying to export Liferay users now

#12 - Jul 17, 2015 04:09 PM - Massimiliano Assante

Updated: we're having troubles mapping users into LDAP, Tom is trying to fix the issue

#13 - Jul 17, 2015 04:59 PM - Massimiliano Assante

Tom fixed the issue, however the users do not seem to get exported from Liferay to LDAP. We're not sure when Liferay would do that (we tried

restarting the portal but no users were exported, we waited 10/15 minutes but no users were exported).

We also found out that (perhaps) the export is not performed on the whole set of portal users. It seems it is only performed per user, when he either

login or changes something in his account, i.e. whenever the user logs on to Liferay, Liferay will automatically export the user to LDAP (or on any type

of update on user. Login changes the LastLoginDate and hence export happens).

If this is confirmed it might be a problem because it will force user to login first and then they will have the possibility to access on redmine. 

I think we should wait a bit more for the export to be done by LR, if LR does not export, then I will take care of creating a periodic task that does the

job on Monday. 

In the meantime we should make sure that Remind is able to work with this new LDAP instance. 

#14 - Jul 20, 2015 12:08 PM - Massimiliano Assante

LR does not export, my feeling is that if the import is not enabled then the export will not work. I'm now going to try to see if i can make it the export

myself.

#15 - Jul 20, 2015 06:26 PM - Massimiliano Assante

- Assignee changed from Massimiliano Assante to Tommaso Piccioli
We are ready to export the users in this new LDAP instance, tomorrow (Tue 21st) Redmine should be plugged to this new LDAP instance during the

D4Science Infrastructure Downtime

#16 - Jul 20, 2015 06:49 PM - Tommaso Piccioli

- Assignee changed from Tommaso Piccioli to Andrea Dell'Amico

#17 - Jul 21, 2015 03:09 PM - Massimiliano Assante

350 production users (circa) were successfully exported to the new LDAP instance (350 is the number of users of services d4science that are

registered at least to one VRE)

#18 - Jul 21, 2015 03:15 PM - Pasquale Pagano

Will you then integrate this list of users with the ones registered to the other portals?

#19 - Jul 21, 2015 03:37 PM - Massimiliano Assante

sure, I will if not today, tomorrow

#20 - Jul 21, 2015 03:37 PM - Massimiliano Assante

Just found out the LDAP instance syncs with Redmine every 30 minutes, if this can't be changed there's no point for the Liferay to LDAP export to be

set every 10 minutes. What should we do?

#21 - Jul 21, 2015 04:18 PM - Massimiliano Assante

descramble users exported successfully 

#22 - Jul 21, 2015 08:12 PM - Andrea Dell'Amico

- Status changed from In Progress to Feedback

The authentication against the second ldap server is now working. There was a problem with the ACLs that is now fixed.

#23 - Jul 21, 2015 08:19 PM - Andrea Dell'Amico

Massimiliano Assante wrote:

Just found out the LDAP instance syncs with Redmine every 30 minutes, if this can't be changed there's no point for the Liferay to LDAP export

to be set every 10 minutes. What should we do?

 About this matter: the syncronization is used by redmine to only merge the changes made on ldap to existing users: email or name changes, for

example. So we do not need to wait for a synchronization to have a new user active, the new users are active as soon as they appear inside the ldap

server.

#24 - Jul 22, 2015 03:40 PM - Massimiliano Assante

I was able to connect Liferay and LDAP, now PARTHENOS VRE users can access Redmine without further authorisations: 

https://services.d4science.org/group/parthenos/issue-tracker, 

however 2 issues remain open:

1) The PARTHENOS VRE users who have not been yet assigned to PARTHENOS Project on RedMine get authenticated but then Redmine says

they have no permission to see the page (obviously)

2) The old LDAP users having a different password on services do not get authenticated as Redmine tries first to authenticate them against the old

LDAP (But passing the new LDAP password)

#25 - Jul 22, 2015 04:50 PM - Massimiliano Assante

- Status changed from Feedback to In Progress

Actually it seems that although the PARTHENOS VRE users were exported to LDAP they are not present in Redmine, e.g. Achille Felicetti is not

present on Redmine 

#26 - Jul 22, 2015 04:50 PM - Massimiliano Assante

Actually it seems that although the PARTHENOS VRE users were exported to LDAP they are not present in Redmine, e.g. Achille Felicetti is not

present on Redmine

#27 - Jul 22, 2015 05:05 PM - Massimiliano Assante
After talking with Andrea he told me the users are in Redmine but in a "locked" state (325 users are in locked state) They have to be unlocked first

manually from Redmine and then you can add them to the Project. I'm not Admin of Redmine i can't do that

#28 - Jul 22, 2015 05:06 PM - Andrea Dell'Amico

Users that are present in the ldap server but did not try to access to redmine yet are in 'locked' state. They are visible from the 'Users' redmine panel,

switching the filter to "locked"

#29 - Jul 22, 2015 05:28 PM - Massimiliano Assante

Thanks Andrea, as a Redmine admin now I can unlock the users. however since they are 350 circa I have to click 350 times.... not fun at all :(

Is it somehow possible to setup Redmine to not lock the users? 

#30 - Jul 22, 2015 05:38 PM - Andrea Dell'Amico

Massimiliano Assante wrote:

Thanks Andrea, as a Redmine admin now I can unlock the users. however since they are 350 circa I have to click 350 times.... not fun at all :(

Is it somehow possible to setup Redmine to not lock the users?

 I'll try. At worst we can modify the database directly

#31 - Jul 22, 2015 07:24 PM - Andrea Dell'Amico

I see that all the users but four where already been unlocked.

From what I'm reading on the ldap sync plugin sources, it's possibile that the users were put in a locked state when we changed the ldap schema.

Let's see what happens with the new ones.

#32 - Jul 23, 2015 10:54 AM - Massimiliano Assante

- File Screen Shot 2015-07-23 at 10.52.22.png added

I did unlock the users yesterday, this morning around 9 i unlocked other 4 users, but now they are back to locked state. The users are the ones in the

screenshot attached (I unlocked them again after taking the screenshot)

#33 - Jul 23, 2015 11:14 AM - Andrea Dell'Amico

They are the same 4 users that I unlocked myself yesterday evening. Y'll try to understand what's wrong with them.

#34 - Jul 23, 2015 11:29 AM - Pasquale Pagano

are the emails actual emails?

#35 - Jul 23, 2015 06:45 PM - Andrea Dell'Amico

Pasquale Pagano wrote:

are the emails actual emails?

 Their syntax is valid.

#36 - Jul 24, 2015 01:10 PM - Andrea Dell'Amico

- Status changed from In Progress to Feedback

I've checked the four users that are currently locked. None of them is present in any of the ldap servers.

statistical.wps and ashtoash do not appear anywhere, while

gerda.mcneil is present with the same email address but uid gerda.mcneill on the old ldap server

jenshaarld.aasheim is present with the same email address but uid j.aasheim on the old ldap server

#38 - Jul 24, 2015 02:12 PM - Massimiliano Assante

sorry Andrea, if None of the four users is present in any of the LDAP servers how can they be in Redmine?

#39 - Jul 24, 2015 03:22 PM - Andrea Dell'Amico

If they are present in one of the portals, maybe they were imported in one of the early ldap tests: the redmine ldap sync process has always been

active.

May 02, 2025 4/5



Why they are not imported into the ldap server anymore, I don't know.

#40 - Jul 27, 2015 01:46 PM - Andrea Dell'Amico

May I remove those four users from redmine?

#41 - Jul 27, 2015 02:31 PM - Pasquale Pagano

Yes, I think so.

#42 - Oct 12, 2015 06:59 PM - Andrea Dell'Amico

- Status changed from Feedback to Resolved

#43 - Nov 30, 2015 06:57 PM - Massimiliano Assante

- Blocked by Support #1407: Export Liferay Portal groups to LDAP added

#44 - Nov 30, 2015 06:58 PM - Massimiliano Assante

- Blocked by Task #1609: Change the Redmine LDAP Configuration dn for users added

#45 - Feb 05, 2016 10:24 AM - Massimiliano Assante

- Status changed from Resolved to Closed
